#ifndef _COMPAT_EVENT_CHANNEL_H
#define _COMPAT_EVENT_CHANNEL_H
#include <xen/compat.h>
#include <public/event_channel.h>
#include "xen.h"
typedef uint32_t evtchn_port_compat_t;
DEFINE_COMPAT_HANDLE(evtchn_port_compat_t);
struct compat_evtchn_alloc_unbound {

    domid_compat_t dom, remote_dom;

    evtchn_port_compat_t port;
};
typedef struct evtchn_alloc_unbound __attribute__((__aligned__(__alignof( struct compat_evtchn_alloc_unbound)))) evtchn_alloc_unbound_compat_t;
struct compat_evtchn_bind_interdomain {

    domid_compat_t remote_dom;
    evtchn_port_compat_t remote_port;

    evtchn_port_compat_t local_port;
};
typedef struct evtchn_bind_interdomain __attribute__((__aligned__(__alignof( struct compat_evtchn_bind_interdomain)))) evtchn_bind_interdomain_compat_t;
struct compat_evtchn_bind_virq {

    uint32_t virq;
    uint32_t vcpu;

    evtchn_port_compat_t port;
};
typedef struct evtchn_bind_virq __attribute__((__aligned__(__alignof( struct compat_evtchn_bind_virq)))) evtchn_bind_virq_compat_t;

struct compat_evtchn_bind_pirq {

    uint32_t pirq;

    uint32_t flags;

    evtchn_port_compat_t port;
};
typedef struct evtchn_bind_pirq __attribute__((__aligned__(__alignof( struct compat_evtchn_bind_pirq)))) evtchn_bind_pirq_compat_t;

struct compat_evtchn_bind_ipi {
    uint32_t vcpu;

    evtchn_port_compat_t port;
};
typedef struct evtchn_bind_ipi __attribute__((__aligned__(__alignof( struct compat_evtchn_bind_ipi)))) evtchn_bind_ipi_compat_t;

struct compat_evtchn_close {

    evtchn_port_compat_t port;
};
typedef struct evtchn_close __attribute__((__aligned__(__alignof( struct compat_evtchn_close)))) evtchn_close_compat_t;

struct compat_evtchn_send {

    evtchn_port_compat_t port;
};
typedef struct evtchn_send __attribute__((__aligned__(__alignof( struct compat_evtchn_send)))) evtchn_send_compat_t;
struct compat_evtchn_status {

    domid_compat_t dom;
    evtchn_port_compat_t port;

    uint32_t status;
    uint32_t vcpu;
    union {
        struct {
            domid_compat_t dom;
        } unbound;
        struct {
            domid_compat_t dom;
            evtchn_port_compat_t port;
        } interdomain;
        uint32_t pirq;
        uint32_t virq;
    } u;
};
typedef struct evtchn_status __attribute__((__aligned__(__alignof( struct compat_evtchn_status)))) evtchn_status_compat_t;
struct compat_evtchn_bind_vcpu {

    evtchn_port_compat_t port;
    uint32_t vcpu;
};
typedef struct evtchn_bind_vcpu __attribute__((__aligned__(__alignof( struct compat_evtchn_bind_vcpu)))) evtchn_bind_vcpu_compat_t;

struct compat_evtchn_unmask {

    evtchn_port_compat_t port;
};
typedef struct evtchn_unmask __attribute__((__aligned__(__alignof( struct compat_evtchn_unmask)))) evtchn_unmask_compat_t;
struct compat_evtchn_reset {

    domid_compat_t dom;
};
typedef struct evtchn_reset __attribute__((__aligned__(__alignof( struct compat_evtchn_reset)))) evtchn_reset_compat_t;
struct compat_evtchn_init_control {

    uint64_compat_t control_gfn;
    uint32_t offset;
    uint32_t vcpu;

    uint8_t link_bits;
    uint8_t _pad[7];
};
typedef struct evtchn_init_control __attribute__((__aligned__(__alignof( struct compat_evtchn_init_control)))) evtchn_init_control_compat_t;

struct compat_evtchn_expand_array {

    uint64_compat_t array_gfn;
};
typedef struct evtchn_expand_array __attribute__((__aligned__(__alignof( struct compat_evtchn_expand_array)))) evtchn_expand_array_compat_t;

struct compat_evtchn_set_priority {

    evtchn_port_compat_t port;
    uint32_t priority;
};
typedef struct evtchn_set_priority __attribute__((__aligned__(__alignof( struct compat_evtchn_set_priority)))) evtchn_set_priority_compat_t;

struct compat_evtchn_op {
    uint32_t cmd;
    union {
        evtchn_alloc_unbound_compat_t alloc_unbound;
        evtchn_bind_interdomain_compat_t bind_interdomain;
        evtchn_bind_virq_compat_t bind_virq;
        evtchn_bind_pirq_compat_t bind_pirq;
        evtchn_bind_ipi_compat_t bind_ipi;
        evtchn_close_compat_t close;
        evtchn_send_compat_t send;
        evtchn_status_compat_t status;
        evtchn_bind_vcpu_compat_t bind_vcpu;
        evtchn_unmask_compat_t unmask;
    } u;
};
typedef struct evtchn_op __attribute__((__aligned__(__alignof( struct compat_evtchn_op)))) evtchn_op_compat_t;
DEFINE_COMPAT_HANDLE(evtchn_op_compat_t);
typedef uint32_t event_word_compat_t;
struct compat_evtchn_fifo_control_block {
    uint32_t ready;
    uint32_t _rsvd;
    uint32_t head[(15 + 1)];
};
typedef struct compat_evtchn_fifo_control_block evtchn_fifo_control_block_compat_t;
#endif /* _COMPAT_EVENT_CHANNEL_H */
